<?xml version="1.0" encoding="ascii"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
          "DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>pyxmpp.jabberd.componentstream</title>
  <link rel="stylesheet" href="epydoc.css" type="text/css" />
  <script type="text/javascript" src="epydoc.js"></script>
</head>

<body bgcolor="white" text="black" link="blue" vlink="#204080"
      alink="#204080">
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table width="100%" cellpadding="0" cellspacing="0">
  <tr valign="top">
    <td width="100%">
      <span class="breadcrumbs">
        <a href="pyxmpp-module.html">Package&nbsp;pyxmpp</a> ::
        <a href="pyxmpp.jabberd-module.html">Package&nbsp;jabberd</a> ::
        Module&nbsp;componentstream
      </span>
    </td>
    <td>
      <table cellpadding="0" cellspacing="0">
        <!-- hide/show private -->
        <tr><td align="right"><span class="options">[<a href="javascript:void(0);" class="privatelink"
    onclick="toggle_private();">hide&nbsp;private</a>]</span></td></tr>
      </table>
    </td>
  </tr>
</table>
<h1 class="epydoc">Source Code for <a href="pyxmpp.jabberd.componentstream-module.html">Module pyxmpp.jabberd.componentstream</a></h1>
<pre class="py-src">
<a name="L1"></a><tt class="py-lineno">  1</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L2"></a><tt class="py-lineno">  2</tt>  <tt class="py-line"><tt class="py-comment"># (C) Copyright 2003-2010 Jacek Konieczny &lt;jajcus@jajcus.net&gt;</tt> </tt>
<a name="L3"></a><tt class="py-lineno">  3</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L4"></a><tt class="py-lineno">  4</tt>  <tt class="py-line"><tt class="py-comment"># This program is free software; you can redistribute it and/or modify</tt> </tt>
<a name="L5"></a><tt class="py-lineno">  5</tt>  <tt class="py-line"><tt class="py-comment"># it under the terms of the GNU Lesser General Public License Version</tt> </tt>
<a name="L6"></a><tt class="py-lineno">  6</tt>  <tt class="py-line"><tt class="py-comment"># 2.1 as published by the Free Software Foundation.</tt> </tt>
<a name="L7"></a><tt class="py-lineno">  7</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L8"></a><tt class="py-lineno">  8</tt>  <tt class="py-line"><tt class="py-comment"># This program is distributed in the hope that it will be useful,</tt> </tt>
<a name="L9"></a><tt class="py-lineno">  9</tt>  <tt class="py-line"><tt class="py-comment"># but WITHOUT ANY WARRANTY; without even the implied warranty of</tt> </tt>
<a name="L10"></a><tt class="py-lineno"> 10</tt>  <tt class="py-line"><tt class="py-comment"># MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</tt> </tt>
<a name="L11"></a><tt class="py-lineno"> 11</tt>  <tt class="py-line"><tt class="py-comment"># GNU Lesser General Public License for more details.</tt> </tt>
<a name="L12"></a><tt class="py-lineno"> 12</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L13"></a><tt class="py-lineno"> 13</tt>  <tt class="py-line"><tt class="py-comment"># You should have received a copy of the GNU Lesser General Public</tt> </tt>
<a name="L14"></a><tt class="py-lineno"> 14</tt>  <tt class="py-line"><tt class="py-comment"># License along with this program; if not, write to the Free Software</tt> </tt>
<a name="L15"></a><tt class="py-lineno"> 15</tt>  <tt class="py-line"><tt class="py-comment"># Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.</tt> </tt>
<a name="L16"></a><tt class="py-lineno"> 16</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L17"></a><tt class="py-lineno"> 17</tt>  <tt class="py-line"><tt class="py-comment"># pylint: disable-msg=W0221, W0201</tt> </tt>
<a name="L18"></a><tt class="py-lineno"> 18</tt>  <tt class="py-line"><tt class="py-docstring">"""Component (jabber:component:accept) stream handling.</tt> </tt>
<a name="L19"></a><tt class="py-lineno"> 19</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L20"></a><tt class="py-lineno"> 20</tt>  <tt class="py-line"><tt class="py-docstring">Normative reference:</tt> </tt>
<a name="L21"></a><tt class="py-lineno"> 21</tt>  <tt class="py-line"><tt class="py-docstring">  - `JEP 114 &lt;http://www.jabber.org/jeps/jep-0114.html&gt;`__</tt> </tt>
<a name="L22"></a><tt class="py-lineno"> 22</tt>  <tt class="py-line"><tt class="py-docstring">"""</tt> </tt>
<a name="L23"></a><tt class="py-lineno"> 23</tt>  <tt class="py-line"> </tt>
<a name="L24"></a><tt class="py-lineno"> 24</tt>  <tt class="py-line"><tt class="py-name">__docformat__</tt><tt class="py-op">=</tt><tt class="py-string">"restructuredtext en"</tt> </tt>
<a name="L25"></a><tt class="py-lineno"> 25</tt>  <tt class="py-line"> </tt>
<a name="L26"></a><tt class="py-lineno"> 26</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">hashlib</tt> </tt>
<a name="L27"></a><tt class="py-lineno"> 27</tt>  <tt class="py-line"> </tt>
<a name="L28"></a><tt class="py-lineno"> 28</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">logging</tt> </tt>
<a name="L29"></a><tt class="py-lineno"> 29</tt>  <tt class="py-line"> </tt>
<a name="L30"></a><tt class="py-lineno"> 30</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt id="link-0" class="py-name" targets="Package pyxmpp=pyxmpp-module.html"><a title="pyxmpp" class="py-name" href="#" onclick="return doclink('link-0', 'pyxmpp', 'link-0');">pyxmpp</a></tt><tt class="py-op">.</tt><tt id="link-1" class="py-name" targets="Variable pyxmpp.jabber.disco.DiscoCacheFetcherBase.stream=pyxmpp.jabber.disco.DiscoCacheFetcherBase-class.html#stream,Module pyxmpp.stream=pyxmpp.stream-module.html"><a title="pyxmpp.jabber.disco.DiscoCacheFetcherBase.stream
pyxmpp.stream" class="py-name" href="#" onclick="return doclink('link-1', 'stream', 'link-1');">stream</a></tt> <tt class="py-keyword">import</tt> <tt id="link-2" class="py-name" targets="Class pyxmpp.stream.Stream=pyxmpp.stream.Stream-class.html"><a title="pyxmpp.stream.Stream" class="py-name" href="#" onclick="return doclink('link-2', 'Stream', 'link-2');">Stream</a></tt> </tt>
<a name="L31"></a><tt class="py-lineno"> 31</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt id="link-3" class="py-name"><a title="pyxmpp" class="py-name" href="#" onclick="return doclink('link-3', 'pyxmpp', 'link-0');">pyxmpp</a></tt><tt class="py-op">.</tt><tt id="link-4" class="py-name" targets="Module pyxmpp.streambase=pyxmpp.streambase-module.html"><a title="pyxmpp.streambase" class="py-name" href="#" onclick="return doclink('link-4', 'streambase', 'link-4');">streambase</a></tt> <tt class="py-keyword">import</tt> <tt id="link-5" class="py-name" targets="Function pyxmpp.streambase.stanza_factory()=pyxmpp.streambase-module.html#stanza_factory"><a title="pyxmpp.streambase.stanza_factory" class="py-name" href="#" onclick="return doclink('link-5', 'stanza_factory', 'link-5');">stanza_factory</a></tt><tt class="py-op">,</tt><tt id="link-6" class="py-name" targets="Class pyxmpp.exceptions.HostMismatch=pyxmpp.exceptions.HostMismatch-class.html"><a title="pyxmpp.exceptions.HostMismatch" class="py-name" href="#" onclick="return doclink('link-6', 'HostMismatch', 'link-6');">HostMismatch</a></tt> </tt>
<a name="L32"></a><tt class="py-lineno"> 32</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt id="link-7" class="py-name"><a title="pyxmpp" class="py-name" href="#" onclick="return doclink('link-7', 'pyxmpp', 'link-0');">pyxmpp</a></tt><tt class="py-op">.</tt><tt id="link-8" class="py-name" targets="Module pyxmpp.xmlextra=pyxmpp.xmlextra-module.html"><a title="pyxmpp.xmlextra" class="py-name" href="#" onclick="return doclink('link-8', 'xmlextra', 'link-8');">xmlextra</a></tt> <tt class="py-keyword">import</tt> <tt id="link-9" class="py-name" targets="Variable pyxmpp.xmlextra.common_doc=pyxmpp.xmlextra-module.html#common_doc"><a title="pyxmpp.xmlextra.common_doc" class="py-name" href="#" onclick="return doclink('link-9', 'common_doc', 'link-9');">common_doc</a></tt><tt class="py-op">,</tt><tt id="link-10" class="py-name" targets="Variable pyxmpp.xmlextra.common_root=pyxmpp.xmlextra-module.html#common_root"><a title="pyxmpp.xmlextra.common_root" class="py-name" href="#" onclick="return doclink('link-10', 'common_root', 'link-10');">common_root</a></tt> </tt>
<a name="L33"></a><tt class="py-lineno"> 33</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt id="link-11" class="py-name"><a title="pyxmpp" class="py-name" href="#" onclick="return doclink('link-11', 'pyxmpp', 'link-0');">pyxmpp</a></tt><tt class="py-op">.</tt><tt id="link-12" class="py-name" targets="Module pyxmpp.utils=pyxmpp.utils-module.html"><a title="pyxmpp.utils" class="py-name" href="#" onclick="return doclink('link-12', 'utils', 'link-12');">utils</a></tt> <tt class="py-keyword">import</tt> <tt id="link-13" class="py-name" targets="Function pyxmpp.utils.to_utf8()=pyxmpp.utils-module.html#to_utf8"><a title="pyxmpp.utils.to_utf8" class="py-name" href="#" onclick="return doclink('link-13', 'to_utf8', 'link-13');">to_utf8</a></tt> </tt>
<a name="L34"></a><tt class="py-lineno"> 34</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt id="link-14" class="py-name"><a title="pyxmpp" class="py-name" href="#" onclick="return doclink('link-14', 'pyxmpp', 'link-0');">pyxmpp</a></tt><tt class="py-op">.</tt><tt id="link-15" class="py-name" targets="Module pyxmpp.exceptions=pyxmpp.exceptions-module.html"><a title="pyxmpp.exceptions" class="py-name" href="#" onclick="return doclink('link-15', 'exceptions', 'link-15');">exceptions</a></tt> <tt class="py-keyword">import</tt> <tt id="link-16" class="py-name" targets="Class pyxmpp.exceptions.StreamError=pyxmpp.exceptions.StreamError-class.html"><a title="pyxmpp.exceptions.StreamError" class="py-name" href="#" onclick="return doclink('link-16', 'StreamError', 'link-16');">StreamError</a></tt><tt class="py-op">,</tt><tt id="link-17" class="py-name" targets="Class pyxmpp.exceptions.FatalStreamError=pyxmpp.exceptions.FatalStreamError-class.html"><a title="pyxmpp.exceptions.FatalStreamError" class="py-name" href="#" onclick="return doclink('link-17', 'FatalStreamError', 'link-17');">FatalStreamError</a></tt><tt class="py-op">,</tt><tt id="link-18" class="py-name" targets="Class pyxmpp.exceptions.ComponentStreamError=pyxmpp.exceptions.ComponentStreamError-class.html"><a title="pyxmpp.exceptions.ComponentStreamError" class="py-name" href="#" onclick="return doclink('link-18', 'ComponentStreamError', 'link-18');">ComponentStreamError</a></tt><tt class="py-op">,</tt><tt id="link-19" class="py-name" targets="Class pyxmpp.exceptions.FatalComponentStreamError=pyxmpp.exceptions.FatalComponentStreamError-class.html"><a title="pyxmpp.exceptions.FatalComponentStreamError" class="py-name" href="#" onclick="return doclink('link-19', 'FatalComponentStreamError', 'link-19');">FatalComponentStreamError</a></tt> </tt>
<a name="L35"></a><tt class="py-lineno"> 35</tt>  <tt class="py-line"> </tt>
<a name="ComponentStream"></a><div id="ComponentStream-def"><a name="L36"></a><tt class="py-lineno"> 36</tt> <a class="py-toggle" href="#" id="ComponentStream-toggle" onclick="return toggle('ComponentStream');">-</a><tt class="py-line"><tt class="py-keyword">class</tt> <a class="py-def-name" href="pyxmpp.jabberd.componentstream.ComponentStream-class.html">ComponentStream</a><tt class="py-op">(</tt><tt class="py-base-class">Stream</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="ComponentStream-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="ComponentStream-expanded"><a name="L37"></a><tt class="py-lineno"> 37</tt>  <tt class="py-line">    <tt class="py-docstring">"""Handles jabberd component (jabber:component:accept) connection stream.</tt> </tt>
<a name="L38"></a><tt class="py-lineno"> 38</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L39"></a><tt class="py-lineno"> 39</tt>  <tt class="py-line"><tt class="py-docstring">    :Ivariables:</tt> </tt>
<a name="L40"></a><tt class="py-lineno"> 40</tt>  <tt class="py-line"><tt class="py-docstring">        - `server`: server to use.</tt> </tt>
<a name="L41"></a><tt class="py-lineno"> 41</tt>  <tt class="py-line"><tt class="py-docstring">        - `port`: port number to use.</tt> </tt>
<a name="L42"></a><tt class="py-lineno"> 42</tt>  <tt class="py-line"><tt class="py-docstring">        - `secret`: authentication secret.</tt> </tt>
<a name="L43"></a><tt class="py-lineno"> 43</tt>  <tt class="py-line"><tt class="py-docstring">    :Types:</tt> </tt>
<a name="L44"></a><tt class="py-lineno"> 44</tt>  <tt class="py-line"><tt class="py-docstring">        - `server`: `unicode`</tt> </tt>
<a name="L45"></a><tt class="py-lineno"> 45</tt>  <tt class="py-line"><tt class="py-docstring">        - `port`: `int`</tt> </tt>
<a name="L46"></a><tt class="py-lineno"> 46</tt>  <tt class="py-line"><tt class="py-docstring">        - `secret`: `unicode`"""</tt> </tt>
<a name="L47"></a><tt class="py-lineno"> 47</tt>  <tt class="py-line"> </tt>
<a name="ComponentStream.__init__"></a><div id="ComponentStream.__init__-def"><a name="L48"></a><tt class="py-lineno"> 48</tt> <a class="py-toggle" href="#" id="ComponentStream.__init__-toggle" onclick="return toggle('ComponentStream.__init__');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jabberd.componentstream.ComponentStream-class.html#__init__">__init__</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">jid</tt><tt class="py-op">,</tt> <tt class="py-param">secret</tt><tt class="py-op">,</tt> <tt class="py-param">server</tt><tt class="py-op">,</tt> <tt class="py-param">port</tt><tt class="py-op">,</tt> <tt class="py-param">keepalive</tt> <tt class="py-op">=</tt> <tt class="py-number">0</tt><tt class="py-op">,</tt> <tt class="py-param">owner</tt> <tt class="py-op">=</tt> <tt class="py-name">None</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="ComponentStream.__init__-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="ComponentStream.__init__-expanded"><a name="L49"></a><tt class="py-lineno"> 49</tt>  <tt class="py-line">        <tt class="py-docstring">"""Initialize a `ComponentStream` object.</tt> </tt>
<a name="L50"></a><tt class="py-lineno"> 50</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L51"></a><tt class="py-lineno"> 51</tt>  <tt class="py-line"><tt class="py-docstring">        :Parameters:</tt> </tt>
<a name="L52"></a><tt class="py-lineno"> 52</tt>  <tt class="py-line"><tt class="py-docstring">            - `jid`: JID of the component.</tt> </tt>
<a name="L53"></a><tt class="py-lineno"> 53</tt>  <tt class="py-line"><tt class="py-docstring">            - `secret`: authentication secret.</tt> </tt>
<a name="L54"></a><tt class="py-lineno"> 54</tt>  <tt class="py-line"><tt class="py-docstring">            - `server`: server address.</tt> </tt>
<a name="L55"></a><tt class="py-lineno"> 55</tt>  <tt class="py-line"><tt class="py-docstring">            - `port`: TCP port number on the server.</tt> </tt>
<a name="L56"></a><tt class="py-lineno"> 56</tt>  <tt class="py-line"><tt class="py-docstring">            - `keepalive`: keepalive interval. 0 to disable.</tt> </tt>
<a name="L57"></a><tt class="py-lineno"> 57</tt>  <tt class="py-line"><tt class="py-docstring">            - `owner`: `Client`, `Component` or similar object "owning" this stream.</tt> </tt>
<a name="L58"></a><tt class="py-lineno"> 58</tt>  <tt class="py-line"><tt class="py-docstring">        """</tt> </tt>
<a name="L59"></a><tt class="py-lineno"> 59</tt>  <tt class="py-line">        <tt id="link-20" class="py-name"><a title="pyxmpp.stream.Stream" class="py-name" href="#" onclick="return doclink('link-20', 'Stream', 'link-2');">Stream</a></tt><tt class="py-op">.</tt><tt id="link-21" class="py-name" targets="Method pyxmpp.cache.Cache.__init__()=pyxmpp.cache.Cache-class.html#__init__,Method pyxmpp.cache.CacheFetcher.__init__()=pyxmpp.cache.CacheFetcher-class.html#__init__,Method pyxmpp.cache.CacheItem.__init__()=pyxmpp.cache.CacheItem-class.html#__init__,Method pyxmpp.cache.CacheSuite.__init__()=pyxmpp.cache.CacheSuite-class.html#__init__,Method pyxmpp.client.Client.__init__()=pyxmpp.client.Client-class.html#__init__,Method pyxmpp.clientstream.ClientStream.__init__()=pyxmpp.clientstream.ClientStream-class.html#__init__,Method pyxmpp.error.ErrorNode.__init__()=pyxmpp.error.ErrorNode-class.html#__init__,Method pyxmpp.error.StanzaErrorNode.__init__()=pyxmpp.error.StanzaErrorNode-class.html#__init__,Method pyxmpp.error.StreamErrorNode.__init__()=pyxmpp.error.StreamErrorNode-class.html#__init__,Method pyxmpp.exceptions.BadRequestProtocolError.__init__()=pyxmpp.exceptions.BadRequestProtocolError-class.html#__init__,Method pyxmpp.exceptions.FeatureNotImplementedProtocolError.__init__()=pyxmpp.exceptions.FeatureNotImplementedProtocolError-class.html#__init__,Method pyxmpp.exceptions.JIDMalformedProtocolError.__init__()=pyxmpp.exceptions.JIDMalformedProtocolError-class.html#__init__,Method pyxmpp.exceptions.ProtocolError.__init__()=pyxmpp.exceptions.ProtocolError-class.html#__init__,Method pyxmpp.expdict.ExpiringDictionary.__init__()=pyxmpp.expdict.ExpiringDictionary-class.html#__init__,Method pyxmpp.interface_micro_impl.Attribute.__init__()=pyxmpp.interface_micro_impl.Attribute-class.html#__init__,Method pyxmpp.interface_micro_impl.InterfaceClass.__init__()=pyxmpp.interface_micro_impl.InterfaceClass-class.html#__init__,Method pyxmpp.iq.Iq.__init__()=pyxmpp.iq.Iq-class.html#__init__,Method pyxmpp.jabber.client.JabberClient.__init__()=pyxmpp.jabber.client.JabberClient-class.html#__init__,Method pyxmpp.jabber.clientstream.LegacyClientStream.__init__()=pyxmpp.jabber.clientstream.LegacyClientStream-class.html#__init__,Method pyxmpp.jabber.dataforms.Field.__init__()=pyxmpp.jabber.dataforms.Field-class.html#__init__,Method pyxmpp.jabber.dataforms.Form.__init__()=pyxmpp.jabber.dataforms.Form-class.html#__init__,Method pyxmpp.jabber.dataforms.Item.__init__()=pyxmpp.jabber.dataforms.Item-class.html#__init__,Method pyxmpp.jabber.dataforms.Option.__init__()=pyxmpp.jabber.dataforms.Option-class.html#__init__,Method pyxmpp.jabber.delay.Delay.__init__()=pyxmpp.jabber.delay.Delay-class.html#__init__,Method pyxmpp.jabber.disco.DiscoIdentity.__init__()=pyxmpp.jabber.disco.DiscoIdentity-class.html#__init__,Method pyxmpp.jabber.disco.DiscoInfo.__init__()=pyxmpp.jabber.disco.DiscoInfo-class.html#__init__,Method pyxmpp.jabber.disco.DiscoItem.__init__()=pyxmpp.jabber.disco.DiscoItem-class.html#__init__,Method pyxmpp.jabber.disco.DiscoItems.__init__()=pyxmpp.jabber.disco.DiscoItems-class.html#__init__,Method pyxmpp.jabber.muc.MucRoomHandler.__init__()=pyxmpp.jabber.muc.MucRoomHandler-class.html#__init__,Method pyxmpp.jabber.muc.MucRoomManager.__init__()=pyxmpp.jabber.muc.MucRoomManager-class.html#__init__,Method pyxmpp.jabber.muc.MucRoomState.__init__()=pyxmpp.jabber.muc.MucRoomState-class.html#__init__,Method pyxmpp.jabber.muc.MucRoomUser.__init__()=pyxmpp.jabber.muc.MucRoomUser-class.html#__init__,Method pyxmpp.jabber.muccore.HistoryParameters.__init__()=pyxmpp.jabber.muccore.HistoryParameters-class.html#__init__,Method pyxmpp.jabber.muccore.MucIq.__init__()=pyxmpp.jabber.muccore.MucIq-class.html#__init__,Method pyxmpp.jabber.muccore.MucItem.__init__()=pyxmpp.jabber.muccore.MucItem-class.html#__init__,Method pyxmpp.jabber.muccore.MucItemBase.__init__()=pyxmpp.jabber.muccore.MucItemBase-class.html#__init__,Method pyxmpp.jabber.muccore.MucPresence.__init__()=pyxmpp.jabber.muccore.MucPresence-class.html#__init__,Method pyxmpp.jabber.muccore.MucStanzaExt.__init__()=pyxmpp.jabber.muccore.MucStanzaExt-class.html#__init__,Method pyxmpp.jabber.muccore.MucStatus.__init__()=pyxmpp.jabber.muccore.MucStatus-class.html#__init__,Method pyxmpp.jabber.muccore.MucX.__init__()=pyxmpp.jabber.muccore.MucX-class.html#__init__,Method pyxmpp.jabber.muccore.MucXBase.__init__()=pyxmpp.jabber.muccore.MucXBase-class.html#__init__,Method pyxmpp.jabber.register.Register.__init__()=pyxmpp.jabber.register.Register-class.html#__init__,Method pyxmpp.jabber.vcard.VCard.__init__()=pyxmpp.jabber.vcard.VCard-class.html#__init__,Method pyxmpp.jabber.vcard.VCardAdr.__init__()=pyxmpp.jabber.vcard.VCardAdr-class.html#__init__,Method pyxmpp.jabber.vcard.VCardCategories.__init__()=pyxmpp.jabber.vcard.VCardCategories-class.html#__init__,Method pyxmpp.jabber.vcard.VCardEmail.__init__()=pyxmpp.jabber.vcard.VCardEmail-class.html#__init__,Method pyxmpp.jabber.vcard.VCardField.__init__()=pyxmpp.jabber.vcard.VCardField-class.html#__init__,Method pyxmpp.jabber.vcard.VCardGeo.__init__()=pyxmpp.jabber.vcard.VCardGeo-class.html#__init__,Method pyxmpp.jabber.vcard.VCardImage.__init__()=pyxmpp.jabber.vcard.VCardImage-class.html#__init__,Method pyxmpp.jabber.vcard.VCardJID.__init__()=pyxmpp.jabber.vcard.VCardJID-class.html#__init__,Method pyxmpp.jabber.vcard.VCardKey.__init__()=pyxmpp.jabber.vcard.VCardKey-class.html#__init__,Method pyxmpp.jabber.vcard.VCardLabel.__init__()=pyxmpp.jabber.vcard.VCardLabel-class.html#__init__,Method pyxmpp.jabber.vcard.VCardName.__init__()=pyxmpp.jabber.vcard.VCardName-class.html#__init__,Method pyxmpp.jabber.vcard.VCardOrg.__init__()=pyxmpp.jabber.vcard.VCardOrg-class.html#__init__,Method pyxmpp.jabber.vcard.VCardPrivacy.__init__()=pyxmpp.jabber.vcard.VCardPrivacy-class.html#__init__,Method pyxmpp.jabber.vcard.VCardSound.__init__()=pyxmpp.jabber.vcard.VCardSound-class.html#__init__,Method pyxmpp.jabber.vcard.VCardString.__init__()=pyxmpp.jabber.vcard.VCardString-class.html#__init__,Method pyxmpp.jabber.vcard.VCardTel.__init__()=pyxmpp.jabber.vcard.VCardTel-class.html#__init__,Method pyxmpp.jabberd.component.Component.__init__()=pyxmpp.jabberd.component.Component-class.html#__init__,Method pyxmpp.jabberd.componentstream.ComponentStream.__init__()=pyxmpp.jabberd.componentstream.ComponentStream-class.html#__init__,Method pyxmpp.message.Message.__init__()=pyxmpp.message.Message-class.html#__init__,Method pyxmpp.presence.Presence.__init__()=pyxmpp.presence.Presence-class.html#__init__,Method pyxmpp.roster.Roster.__init__()=pyxmpp.roster.Roster-class.html#__init__,Method pyxmpp.roster.RosterItem.__init__()=pyxmpp.roster.RosterItem-class.html#__init__,Method pyxmpp.sasl.core.Challenge.__init__()=pyxmpp.sasl.core.Challenge-class.html#__init__,Method pyxmpp.sasl.core.ClientAuthenticator.__init__()=pyxmpp.sasl.core.ClientAuthenticator-class.html#__init__,Method pyxmpp.sasl.core.Failure.__init__()=pyxmpp.sasl.core.Failure-class.html#__init__,Method pyxmpp.sasl.core.PasswordManager.__init__()=pyxmpp.sasl.core.PasswordManager-class.html#__init__,Method pyxmpp.sasl.core.Reply.__init__()=pyxmpp.sasl.core.Reply-class.html#__init__,Method pyxmpp.sasl.core.Response.__init__()=pyxmpp.sasl.core.Response-class.html#__init__,Method pyxmpp.sasl.core.ServerAuthenticator.__init__()=pyxmpp.sasl.core.ServerAuthenticator-class.html#__init__,Method pyxmpp.sasl.core.Success.__init__()=pyxmpp.sasl.core.Success-class.html#__init__,Method pyxmpp.sasl.digest_md5.DigestMD5ClientAuthenticator.__init__()=pyxmpp.sasl.digest_md5.DigestMD5ClientAuthenticator-class.html#__init__,Method pyxmpp.sasl.digest_md5.DigestMD5ServerAuthenticator.__init__()=pyxmpp.sasl.digest_md5.DigestMD5ServerAuthenticator-class.html#__init__,Method pyxmpp.sasl.external.ExternalClientAuthenticator.__init__()=pyxmpp.sasl.external.ExternalClientAuthenticator-class.html#__init__,Method pyxmpp.sasl.gssapi.GSSAPIClientAuthenticator.__init__()=pyxmpp.sasl.gssapi.GSSAPIClientAuthenticator-class.html#__init__,Method pyxmpp.sasl.plain.PlainClientAuthenticator.__init__()=pyxmpp.sasl.plain.PlainClientAuthenticator-class.html#__init__,Method pyxmpp.sasl.plain.PlainServerAuthenticator.__init__()=pyxmpp.sasl.plain.PlainServerAuthenticator-class.html#__init__,Method pyxmpp.stanza.Stanza.__init__()=pyxmpp.stanza.Stanza-class.html#__init__,Method pyxmpp.stanzaprocessor.StanzaProcessor.__init__()=pyxmpp.stanzaprocessor.StanzaProcessor-class.html#__init__,Method pyxmpp.stream.Stream.__init__()=pyxmpp.stream.Stream-class.html#__init__,Method pyxmpp.streambase.StreamBase.__init__()=pyxmpp.streambase.StreamBase-class.html#__init__,Method pyxmpp.streamsasl.StreamSASLMixIn.__init__()=pyxmpp.streamsasl.StreamSASLMixIn-class.html#__init__,Method pyxmpp.streamtls.StreamTLSMixIn.__init__()=pyxmpp.streamtls.StreamTLSMixIn-class.html#__init__,Method pyxmpp.streamtls.TLSSettings.__init__()=pyxmpp.streamtls.TLSSettings-class.html#__init__,Method pyxmpp.xmlextra.StreamHandler.__init__()=pyxmpp.xmlextra.StreamHandler-class.html#__init__,Method pyxmpp.xmlextra.StreamReader.__init__()=pyxmpp.xmlextra.StreamReader-class.html#__init__,Method pyxmpp.xmlextra._PythonReader.__init__()=pyxmpp.xmlextra._PythonReader-class.html#__init__,Method pyxmpp.xmlextra._SAXCallback.__init__()=pyxmpp.xmlextra._SAXCallback-class.html#__init__,Method pyxmpp.xmppstringprep.LookupFunction.__init__()=pyxmpp.xmppstringprep.LookupFunction-class.html#__init__,Method pyxmpp.xmppstringprep.LookupTable.__init__()=pyxmpp.xmppstringprep.LookupTable-class.html#__init__,Method pyxmpp.xmppstringprep.Profile.__init__()=pyxmpp.xmppstringprep.Profile-class.html#__init__"><a title="pyxmpp.cache.Cache.__init__
pyxmpp.cache.CacheFetcher.__init__
pyxmpp.cache.CacheItem.__init__
pyxmpp.cache.CacheSuite.__init__
pyxmpp.client.Client.__init__
pyxmpp.clientstream.ClientStream.__init__
pyxmpp.error.ErrorNode.__init__
pyxmpp.error.StanzaErrorNode.__init__
pyxmpp.error.StreamErrorNode.__init__
pyxmpp.exceptions.BadRequestProtocolError.__init__
pyxmpp.exceptions.FeatureNotImplementedProtocolError.__init__
pyxmpp.exceptions.JIDMalformedProtocolError.__init__
pyxmpp.exceptions.ProtocolError.__init__
pyxmpp.expdict.ExpiringDictionary.__init__
pyxmpp.interface_micro_impl.Attribute.__init__
pyxmpp.interface_micro_impl.InterfaceClass.__init__
pyxmpp.iq.Iq.__init__
pyxmpp.jabber.client.JabberClient.__init__
pyxmpp.jabber.clientstream.LegacyClientStream.__init__
pyxmpp.jabber.dataforms.Field.__init__
pyxmpp.jabber.dataforms.Form.__init__
pyxmpp.jabber.dataforms.Item.__init__
pyxmpp.jabber.dataforms.Option.__init__
pyxmpp.jabber.delay.Delay.__init__
pyxmpp.jabber.disco.DiscoIdentity.__init__
pyxmpp.jabber.disco.DiscoInfo.__init__
pyxmpp.jabber.disco.DiscoItem.__init__
pyxmpp.jabber.disco.DiscoItems.__init__
pyxmpp.jabber.muc.MucRoomHandler.__init__
pyxmpp.jabber.muc.MucRoomManager.__init__
pyxmpp.jabber.muc.MucRoomState.__init__
pyxmpp.jabber.muc.MucRoomUser.__init__
pyxmpp.jabber.muccore.HistoryParameters.__init__
pyxmpp.jabber.muccore.MucIq.__init__
pyxmpp.jabber.muccore.MucItem.__init__
pyxmpp.jabber.muccore.MucItemBase.__init__
pyxmpp.jabber.muccore.MucPresence.__init__
pyxmpp.jabber.muccore.MucStanzaExt.__init__
pyxmpp.jabber.muccore.MucStatus.__init__
pyxmpp.jabber.muccore.MucX.__init__
pyxmpp.jabber.muccore.MucXBase.__init__
pyxmpp.jabber.register.Register.__init__
pyxmpp.jabber.vcard.VCard.__init__
pyxmpp.jabber.vcard.VCardAdr.__init__
pyxmpp.jabber.vcard.VCardCategories.__init__
pyxmpp.jabber.vcard.VCardEmail.__init__
pyxmpp.jabber.vcard.VCardField.__init__
pyxmpp.jabber.vcard.VCardGeo.__init__
pyxmpp.jabber.vcard.VCardImage.__init__
pyxmpp.jabber.vcard.VCardJID.__init__
pyxmpp.jabber.vcard.VCardKey.__init__
pyxmpp.jabber.vcard.VCardLabel.__init__
pyxmpp.jabber.vcard.VCardName.__init__
pyxmpp.jabber.vcard.VCardOrg.__init__
pyxmpp.jabber.vcard.VCardPrivacy.__init__
pyxmpp.jabber.vcard.VCardSound.__init__
pyxmpp.jabber.vcard.VCardString.__init__
pyxmpp.jabber.vcard.VCardTel.__init__
pyxmpp.jabberd.component.Component.__init__
pyxmpp.jabberd.componentstream.ComponentStream.__init__
pyxmpp.message.Message.__init__
pyxmpp.presence.Presence.__init__
pyxmpp.roster.Roster.__init__
pyxmpp.roster.RosterItem.__init__
pyxmpp.sasl.core.Challenge.__init__
pyxmpp.sasl.core.ClientAuthenticator.__init__
pyxmpp.sasl.core.Failure.__init__
pyxmpp.sasl.core.PasswordManager.__init__
pyxmpp.sasl.core.Reply.__init__
pyxmpp.sasl.core.Response.__init__
pyxmpp.sasl.core.ServerAuthenticator.__init__
pyxmpp.sasl.core.Success.__init__
pyxmpp.sasl.digest_md5.DigestMD5ClientAuthenticator.__init__
pyxmpp.sasl.digest_md5.DigestMD5ServerAuthenticator.__init__
pyxmpp.sasl.external.ExternalClientAuthenticator.__init__
pyxmpp.sasl.gssapi.GSSAPIClientAuthenticator.__init__
pyxmpp.sasl.plain.PlainClientAuthenticator.__init__
pyxmpp.sasl.plain.PlainServerAuthenticator.__init__
pyxmpp.stanza.Stanza.__init__
pyxmpp.stanzaprocessor.StanzaProcessor.__init__
pyxmpp.stream.Stream.__init__
pyxmpp.streambase.StreamBase.__init__
pyxmpp.streamsasl.StreamSASLMixIn.__init__
pyxmpp.streamtls.StreamTLSMixIn.__init__
pyxmpp.streamtls.TLSSettings.__init__
pyxmpp.xmlextra.StreamHandler.__init__
pyxmpp.xmlextra.StreamReader.__init__
pyxmpp.xmlextra._PythonReader.__init__
pyxmpp.xmlextra._SAXCallback.__init__
pyxmpp.xmppstringprep.LookupFunction.__init__
pyxmpp.xmppstringprep.LookupTable.__init__
pyxmpp.xmppstringprep.Profile.__init__" class="py-name" href="#" onclick="return doclink('link-21', '__init__', 'link-21');">__init__</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">,</tt> <tt class="py-string">"jabber:component:accept"</tt><tt class="py-op">,</tt> </tt>
<a name="L60"></a><tt class="py-lineno"> 60</tt>  <tt class="py-line">                    <tt class="py-name">sasl_mechanisms</tt> <tt class="py-op">=</tt> <tt class="py-op">[</tt><tt class="py-op">]</tt><tt class="py-op">,</tt> </tt>
<a name="L61"></a><tt class="py-lineno"> 61</tt>  <tt class="py-line">                    <tt class="py-name">tls_settings</tt> <tt class="py-op">=</tt> <tt class="py-name">None</tt><tt class="py-op">,</tt> </tt>
<a name="L62"></a><tt class="py-lineno"> 62</tt>  <tt class="py-line">                    <tt class="py-name">keepalive</tt> <tt class="py-op">=</tt> <tt class="py-name">keepalive</tt><tt class="py-op">,</tt> </tt>
<a name="L63"></a><tt class="py-lineno"> 63</tt>  <tt class="py-line">                    <tt class="py-name">owner</tt> <tt class="py-op">=</tt> <tt class="py-name">owner</tt><tt class="py-op">)</tt> </tt>
<a name="L64"></a><tt class="py-lineno"> 64</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">server</tt><tt class="py-op">=</tt><tt class="py-name">server</tt> </tt>
<a name="L65"></a><tt class="py-lineno"> 65</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">port</tt><tt class="py-op">=</tt><tt class="py-name">port</tt> </tt>
<a name="L66"></a><tt class="py-lineno"> 66</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">me</tt><tt class="py-op">=</tt><tt id="link-22" class="py-name" targets="Variable pyxmpp.jabber.disco.DiscoItem.jid=pyxmpp.jabber.disco.DiscoItem-class.html#jid,Module pyxmpp.jid=pyxmpp.jid-module.html"><a title="pyxmpp.jabber.disco.DiscoItem.jid
pyxmpp.jid" class="py-name" href="#" onclick="return doclink('link-22', 'jid', 'link-22');">jid</a></tt> </tt>
<a name="L67"></a><tt class="py-lineno"> 67</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">secret</tt><tt class="py-op">=</tt><tt class="py-name">secret</tt> </tt>
<a name="L68"></a><tt class="py-lineno"> 68</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">process_all_stanzas</tt><tt class="py-op">=</tt><tt class="py-number">1</tt> </tt>
<a name="L69"></a><tt class="py-lineno"> 69</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">__logger</tt><tt class="py-op">=</tt><tt class="py-name">logging</tt><tt class="py-op">.</tt><tt class="py-name">getLogger</tt><tt class="py-op">(</tt><tt class="py-string">"pyxmpp.jabberd.ComponentStream"</tt><tt class="py-op">)</tt> </tt>
</div><a name="L70"></a><tt class="py-lineno"> 70</tt>  <tt class="py-line"> </tt>
<a name="ComponentStream._reset"></a><div id="ComponentStream._reset-def"><a name="L71"></a><tt class="py-lineno"> 71</tt> <a class="py-toggle" href="#" id="ComponentStream._reset-toggle" onclick="return toggle('ComponentStream._reset');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jabberd.componentstream.ComponentStream-class.html#_reset">_reset</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="ComponentStream._reset-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="ComponentStream._reset-expanded"><a name="L72"></a><tt class="py-lineno"> 72</tt>  <tt class="py-line">        <tt class="py-docstring">"""Reset `ComponentStream` object state, making the object ready to</tt> </tt>
<a name="L73"></a><tt class="py-lineno"> 73</tt>  <tt class="py-line"><tt class="py-docstring">        handle new connections."""</tt> </tt>
<a name="L74"></a><tt class="py-lineno"> 74</tt>  <tt class="py-line">        <tt id="link-23" class="py-name"><a title="pyxmpp.stream.Stream" class="py-name" href="#" onclick="return doclink('link-23', 'Stream', 'link-2');">Stream</a></tt><tt class="py-op">.</tt><tt id="link-24" class="py-name" targets="Method pyxmpp.clientstream.ClientStream._reset()=pyxmpp.clientstream.ClientStream-class.html#_reset,Method pyxmpp.jabber.clientstream.LegacyClientStream._reset()=pyxmpp.jabber.clientstream.LegacyClientStream-class.html#_reset,Method pyxmpp.jabberd.componentstream.ComponentStream._reset()=pyxmpp.jabberd.componentstream.ComponentStream-class.html#_reset,Method pyxmpp.stream.Stream._reset()=pyxmpp.stream.Stream-class.html#_reset,Method pyxmpp.streambase.StreamBase._reset()=pyxmpp.streambase.StreamBase-class.html#_reset"><a title="pyxmpp.clientstream.ClientStream._reset
pyxmpp.jabber.clientstream.LegacyClientStream._reset
pyxmpp.jabberd.componentstream.ComponentStream._reset
pyxmpp.stream.Stream._reset
pyxmpp.streambase.StreamBase._reset" class="py-name" href="#" onclick="return doclink('link-24', '_reset', 'link-24');">_reset</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">)</tt> </tt>
</div><a name="L75"></a><tt class="py-lineno"> 75</tt>  <tt class="py-line"> </tt>
<a name="ComponentStream.connect"></a><div id="ComponentStream.connect-def"><a name="L76"></a><tt class="py-lineno"> 76</tt> <a class="py-toggle" href="#" id="ComponentStream.connect-toggle" onclick="return toggle('ComponentStream.connect');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jabberd.componentstream.ComponentStream-class.html#connect">connect</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">server</tt><tt class="py-op">=</tt><tt class="py-name">None</tt><tt class="py-op">,</tt><tt class="py-param">port</tt><tt class="py-op">=</tt><tt class="py-name">None</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="ComponentStream.connect-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="ComponentStream.connect-expanded"><a name="L77"></a><tt class="py-lineno"> 77</tt>  <tt class="py-line">        <tt class="py-docstring">"""Establish a client connection to a server.</tt> </tt>
<a name="L78"></a><tt class="py-lineno"> 78</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L79"></a><tt class="py-lineno"> 79</tt>  <tt class="py-line"><tt class="py-docstring">        [component only]</tt> </tt>
<a name="L80"></a><tt class="py-lineno"> 80</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L81"></a><tt class="py-lineno"> 81</tt>  <tt class="py-line"><tt class="py-docstring">        :Parameters:</tt> </tt>
<a name="L82"></a><tt class="py-lineno"> 82</tt>  <tt class="py-line"><tt class="py-docstring">            - `server`: name or address of the server to use.  If not given</tt> </tt>
<a name="L83"></a><tt class="py-lineno"> 83</tt>  <tt class="py-line"><tt class="py-docstring">              then use the one specified when creating the object.</tt> </tt>
<a name="L84"></a><tt class="py-lineno"> 84</tt>  <tt class="py-line"><tt class="py-docstring">            - `port`: port number of the server to use.  If not given then use</tt> </tt>
<a name="L85"></a><tt class="py-lineno"> 85</tt>  <tt class="py-line"><tt class="py-docstring">              the one specified when creating the object.</tt> </tt>
<a name="L86"></a><tt class="py-lineno"> 86</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L87"></a><tt class="py-lineno"> 87</tt>  <tt class="py-line"><tt class="py-docstring">        :Types:</tt> </tt>
<a name="L88"></a><tt class="py-lineno"> 88</tt>  <tt class="py-line"><tt class="py-docstring">            - `server`: `unicode`</tt> </tt>
<a name="L89"></a><tt class="py-lineno"> 89</tt>  <tt class="py-line"><tt class="py-docstring">            - `port`: `int`"""</tt> </tt>
<a name="L90"></a><tt class="py-lineno"> 90</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">lock</tt><tt class="py-op">.</tt><tt class="py-name">acquire</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L91"></a><tt class="py-lineno"> 91</tt>  <tt class="py-line">        <tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L92"></a><tt class="py-lineno"> 92</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-25" class="py-name" targets="Method pyxmpp.clientstream.ClientStream._connect()=pyxmpp.clientstream.ClientStream-class.html#_connect,Method pyxmpp.jabberd.componentstream.ComponentStream._connect()=pyxmpp.jabberd.componentstream.ComponentStream-class.html#_connect,Method pyxmpp.streambase.StreamBase._connect()=pyxmpp.streambase.StreamBase-class.html#_connect"><a title="pyxmpp.clientstream.ClientStream._connect
pyxmpp.jabberd.componentstream.ComponentStream._connect
pyxmpp.streambase.StreamBase._connect" class="py-name" href="#" onclick="return doclink('link-25', '_connect', 'link-25');">_connect</a></tt><tt class="py-op">(</tt><tt class="py-name">server</tt><tt class="py-op">,</tt><tt class="py-name">port</tt><tt class="py-op">)</tt> </tt>
<a name="L93"></a><tt class="py-lineno"> 93</tt>  <tt class="py-line">        <tt class="py-keyword">finally</tt><tt class="py-op">:</tt> </tt>
<a name="L94"></a><tt class="py-lineno"> 94</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">lock</tt><tt class="py-op">.</tt><tt class="py-name">release</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
</div><a name="L95"></a><tt class="py-lineno"> 95</tt>  <tt class="py-line"> </tt>
<a name="ComponentStream._connect"></a><div id="ComponentStream._connect-def"><a name="L96"></a><tt class="py-lineno"> 96</tt> <a class="py-toggle" href="#" id="ComponentStream._connect-toggle" onclick="return toggle('ComponentStream._connect');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jabberd.componentstream.ComponentStream-class.html#_connect">_connect</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">server</tt><tt class="py-op">=</tt><tt class="py-name">None</tt><tt class="py-op">,</tt><tt class="py-param">port</tt><tt class="py-op">=</tt><tt class="py-name">None</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="ComponentStream._connect-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="ComponentStream._connect-expanded"><a name="L97"></a><tt class="py-lineno"> 97</tt>  <tt class="py-line">        <tt class="py-docstring">"""Same as `ComponentStream.connect` but assume `self.lock` is acquired."""</tt> </tt>
<a name="L98"></a><tt class="py-lineno"> 98</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">me</tt><tt class="py-op">.</tt><tt id="link-26" class="py-name" targets="Variable pyxmpp.jabber.disco.DiscoInfo.node=pyxmpp.jabber.disco.DiscoInfo-class.html#node,Variable pyxmpp.jabber.disco.DiscoItem.node=pyxmpp.jabber.disco.DiscoItem-class.html#node,Variable pyxmpp.jabber.disco.DiscoItems.node=pyxmpp.jabber.disco.DiscoItems-class.html#node,Variable pyxmpp.jid.JID.node=pyxmpp.jid.JID-class.html#node"><a title="pyxmpp.jabber.disco.DiscoInfo.node
pyxmpp.jabber.disco.DiscoItem.node
pyxmpp.jabber.disco.DiscoItems.node
pyxmpp.jid.JID.node" class="py-name" href="#" onclick="return doclink('link-26', 'node', 'link-26');">node</a></tt> <tt class="py-keyword">or</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">me</tt><tt class="py-op">.</tt><tt id="link-27" class="py-name" targets="Variable pyxmpp.jid.JID.resource=pyxmpp.jid.JID-class.html#resource"><a title="pyxmpp.jid.JID.resource" class="py-name" href="#" onclick="return doclink('link-27', 'resource', 'link-27');">resource</a></tt><tt class="py-op">:</tt> </tt>
<a name="L99"></a><tt class="py-lineno"> 99</tt>  <tt class="py-line">            <tt class="py-keyword">raise</tt> <tt class="py-name">Value</tt><tt class="py-op">,</tt> <tt class="py-string">"Component JID may have only domain defined"</tt> </tt>
<a name="L100"></a><tt class="py-lineno">100</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-keyword">not</tt> <tt class="py-name">server</tt><tt class="py-op">:</tt> </tt>
<a name="L101"></a><tt class="py-lineno">101</tt>  <tt class="py-line">            <tt class="py-name">server</tt><tt class="py-op">=</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">server</tt> </tt>
<a name="L102"></a><tt class="py-lineno">102</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-keyword">not</tt> <tt class="py-name">port</tt><tt class="py-op">:</tt> </tt>
<a name="L103"></a><tt class="py-lineno">103</tt>  <tt class="py-line">            <tt class="py-name">port</tt><tt class="py-op">=</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">port</tt> </tt>
<a name="L104"></a><tt class="py-lineno">104</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-keyword">not</tt> <tt class="py-name">server</tt> <tt class="py-keyword">or</tt> <tt class="py-keyword">not</tt> <tt class="py-name">port</tt><tt class="py-op">:</tt> </tt>
<a name="L105"></a><tt class="py-lineno">105</tt>  <tt class="py-line">            <tt class="py-keyword">raise</tt> <tt class="py-name">ValueError</tt><tt class="py-op">,</tt> <tt class="py-string">"Server or port not given"</tt> </tt>
<a name="L106"></a><tt class="py-lineno">106</tt>  <tt class="py-line">        <tt id="link-28" class="py-name"><a title="pyxmpp.stream.Stream" class="py-name" href="#" onclick="return doclink('link-28', 'Stream', 'link-2');">Stream</a></tt><tt class="py-op">.</tt><tt id="link-29" class="py-name"><a title="pyxmpp.clientstream.ClientStream._connect
pyxmpp.jabberd.componentstream.ComponentStream._connect
pyxmpp.streambase.StreamBase._connect" class="py-name" href="#" onclick="return doclink('link-29', '_connect', 'link-25');">_connect</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">,</tt><tt class="py-name">server</tt><tt class="py-op">,</tt><tt class="py-name">port</tt><tt class="py-op">,</tt><tt class="py-name">None</tt><tt class="py-op">,</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">me</tt><tt class="py-op">)</tt> </tt>
</div><a name="L107"></a><tt class="py-lineno">107</tt>  <tt class="py-line"> </tt>
<a name="ComponentStream.accept"></a><div id="ComponentStream.accept-def"><a name="L108"></a><tt class="py-lineno">108</tt> <a class="py-toggle" href="#" id="ComponentStream.accept-toggle" onclick="return toggle('ComponentStream.accept');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jabberd.componentstream.ComponentStream-class.html#accept">accept</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">sock</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="ComponentStream.accept-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="ComponentStream.accept-expanded"><a name="L109"></a><tt class="py-lineno">109</tt>  <tt class="py-line">        <tt class="py-docstring">"""Accept an incoming component connection.</tt> </tt>
<a name="L110"></a><tt class="py-lineno">110</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L111"></a><tt class="py-lineno">111</tt>  <tt class="py-line"><tt class="py-docstring">        [server only]</tt> </tt>
<a name="L112"></a><tt class="py-lineno">112</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L113"></a><tt class="py-lineno">113</tt>  <tt class="py-line"><tt class="py-docstring">        :Parameters:</tt> </tt>
<a name="L114"></a><tt class="py-lineno">114</tt>  <tt class="py-line"><tt class="py-docstring">            - `sock`: a listening socket."""</tt> </tt>
<a name="L115"></a><tt class="py-lineno">115</tt>  <tt class="py-line">        <tt id="link-30" class="py-name"><a title="pyxmpp.stream.Stream" class="py-name" href="#" onclick="return doclink('link-30', 'Stream', 'link-2');">Stream</a></tt><tt class="py-op">.</tt><tt id="link-31" class="py-name" targets="Method pyxmpp.clientstream.ClientStream.accept()=pyxmpp.clientstream.ClientStream-class.html#accept,Method pyxmpp.jabberd.componentstream.ComponentStream.accept()=pyxmpp.jabberd.componentstream.ComponentStream-class.html#accept,Method pyxmpp.streambase.StreamBase.accept()=pyxmpp.streambase.StreamBase-class.html#accept"><a title="pyxmpp.clientstream.ClientStream.accept
pyxmpp.jabberd.componentstream.ComponentStream.accept
pyxmpp.streambase.StreamBase.accept" class="py-name" href="#" onclick="return doclink('link-31', 'accept', 'link-31');">accept</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">,</tt><tt class="py-name">sock</tt><tt class="py-op">,</tt><tt class="py-name">None</tt><tt class="py-op">)</tt> </tt>
</div><a name="L116"></a><tt class="py-lineno">116</tt>  <tt class="py-line"> </tt>
<a name="ComponentStream.stream_start"></a><div id="ComponentStream.stream_start-def"><a name="L117"></a><tt class="py-lineno">117</tt> <a class="py-toggle" href="#" id="ComponentStream.stream_start-toggle" onclick="return toggle('ComponentStream.stream_start');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jabberd.componentstream.ComponentStream-class.html#stream_start">stream_start</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">doc</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="ComponentStream.stream_start-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="ComponentStream.stream_start-expanded"><a name="L118"></a><tt class="py-lineno">118</tt>  <tt class="py-line">        <tt class="py-docstring">"""Process &lt;stream:stream&gt; (stream start) tag received from peer.</tt> </tt>
<a name="L119"></a><tt class="py-lineno">119</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L120"></a><tt class="py-lineno">120</tt>  <tt class="py-line"><tt class="py-docstring">        Call `Stream.stream_start`, but ignore any `HostMismatch` error.</tt> </tt>
<a name="L121"></a><tt class="py-lineno">121</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L122"></a><tt class="py-lineno">122</tt>  <tt class="py-line"><tt class="py-docstring">        :Parameters:</tt> </tt>
<a name="L123"></a><tt class="py-lineno">123</tt>  <tt class="py-line"><tt class="py-docstring">            - `doc`: document created by the parser"""</tt> </tt>
<a name="L124"></a><tt class="py-lineno">124</tt>  <tt class="py-line">        <tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L125"></a><tt class="py-lineno">125</tt>  <tt class="py-line">            <tt id="link-32" class="py-name"><a title="pyxmpp.stream.Stream" class="py-name" href="#" onclick="return doclink('link-32', 'Stream', 'link-2');">Stream</a></tt><tt class="py-op">.</tt><tt id="link-33" class="py-name" targets="Method pyxmpp.jabberd.componentstream.ComponentStream.stream_start()=pyxmpp.jabberd.componentstream.ComponentStream-class.html#stream_start,Method pyxmpp.streambase.StreamBase.stream_start()=pyxmpp.streambase.StreamBase-class.html#stream_start,Method pyxmpp.xmlextra.StreamHandler.stream_start()=pyxmpp.xmlextra.StreamHandler-class.html#stream_start"><a title="pyxmpp.jabberd.componentstream.ComponentStream.stream_start
pyxmpp.streambase.StreamBase.stream_start
pyxmpp.xmlextra.StreamHandler.stream_start" class="py-name" href="#" onclick="return doclink('link-33', 'stream_start', 'link-33');">stream_start</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">,</tt><tt id="link-34" class="py-name" targets="Method pyxmpp.xmlextra.StreamReader.doc()=pyxmpp.xmlextra.StreamReader-class.html#doc"><a title="pyxmpp.xmlextra.StreamReader.doc" class="py-name" href="#" onclick="return doclink('link-34', 'doc', 'link-34');">doc</a></tt><tt class="py-op">)</tt> </tt>
<a name="L126"></a><tt class="py-lineno">126</tt>  <tt class="py-line">        <tt class="py-keyword">except</tt> <tt id="link-35" class="py-name"><a title="pyxmpp.exceptions.HostMismatch" class="py-name" href="#" onclick="return doclink('link-35', 'HostMismatch', 'link-6');">HostMismatch</a></tt><tt class="py-op">:</tt> </tt>
<a name="L127"></a><tt class="py-lineno">127</tt>  <tt class="py-line">            <tt class="py-keyword">pass</tt> </tt>
</div><a name="L128"></a><tt class="py-lineno">128</tt>  <tt class="py-line"> </tt>
<a name="ComponentStream._post_connect"></a><div id="ComponentStream._post_connect-def"><a name="L129"></a><tt class="py-lineno">129</tt> <a class="py-toggle" href="#" id="ComponentStream._post_connect-toggle" onclick="return toggle('ComponentStream._post_connect');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jabberd.componentstream.ComponentStream-class.html#_post_connect">_post_connect</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="ComponentStream._post_connect-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="ComponentStream._post_connect-expanded"><a name="L130"></a><tt class="py-lineno">130</tt>  <tt class="py-line">        <tt class="py-docstring">"""Initialize authentication when the connection is established</tt> </tt>
<a name="L131"></a><tt class="py-lineno">131</tt>  <tt class="py-line"><tt class="py-docstring">        and we are the initiator."""</tt> </tt>
<a name="L132"></a><tt class="py-lineno">132</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">initiator</tt><tt class="py-op">:</tt> </tt>
<a name="L133"></a><tt class="py-lineno">133</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-36" class="py-name" targets="Method pyxmpp.jabberd.componentstream.ComponentStream._auth()=pyxmpp.jabberd.componentstream.ComponentStream-class.html#_auth"><a title="pyxmpp.jabberd.componentstream.ComponentStream._auth" class="py-name" href="#" onclick="return doclink('link-36', '_auth', 'link-36');">_auth</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
</div><a name="L134"></a><tt class="py-lineno">134</tt>  <tt class="py-line"> </tt>
<a name="ComponentStream._compute_handshake"></a><div id="ComponentStream._compute_handshake-def"><a name="L135"></a><tt class="py-lineno">135</tt> <a class="py-toggle" href="#" id="ComponentStream._compute_handshake-toggle" onclick="return toggle('ComponentStream._compute_handshake');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jabberd.componentstream.ComponentStream-class.html#_compute_handshake">_compute_handshake</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="ComponentStream._compute_handshake-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="ComponentStream._compute_handshake-expanded"><a name="L136"></a><tt class="py-lineno">136</tt>  <tt class="py-line">        <tt class="py-docstring">"""Compute the authentication handshake value.</tt> </tt>
<a name="L137"></a><tt class="py-lineno">137</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L138"></a><tt class="py-lineno">138</tt>  <tt class="py-line"><tt class="py-docstring">        :return: the computed hash value.</tt> </tt>
<a name="L139"></a><tt class="py-lineno">139</tt>  <tt class="py-line"><tt class="py-docstring">        :returntype: `str`"""</tt> </tt>
<a name="L140"></a><tt class="py-lineno">140</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-name">hashlib</tt><tt class="py-op">.</tt><tt class="py-name">sha1</tt><tt class="py-op">(</tt><tt id="link-37" class="py-name"><a title="pyxmpp.utils.to_utf8" class="py-name" href="#" onclick="return doclink('link-37', 'to_utf8', 'link-13');">to_utf8</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">stream_id</tt><tt class="py-op">)</tt><tt class="py-op">+</tt><tt id="link-38" class="py-name"><a title="pyxmpp.utils.to_utf8" class="py-name" href="#" onclick="return doclink('link-38', 'to_utf8', 'link-13');">to_utf8</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">secret</tt><tt class="py-op">)</tt><tt class="py-op">)</tt><tt class="py-op">.</tt><tt class="py-name">hexdigest</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
</div><a name="L141"></a><tt class="py-lineno">141</tt>  <tt class="py-line"> </tt>
<a name="ComponentStream._auth"></a><div id="ComponentStream._auth-def"><a name="L142"></a><tt class="py-lineno">142</tt> <a class="py-toggle" href="#" id="ComponentStream._auth-toggle" onclick="return toggle('ComponentStream._auth');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jabberd.componentstream.ComponentStream-class.html#_auth">_auth</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="ComponentStream._auth-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="ComponentStream._auth-expanded"><a name="L143"></a><tt class="py-lineno">143</tt>  <tt class="py-line">        <tt class="py-docstring">"""Authenticate on the server.</tt> </tt>
<a name="L144"></a><tt class="py-lineno">144</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L145"></a><tt class="py-lineno">145</tt>  <tt class="py-line"><tt class="py-docstring">        [component only]"""</tt> </tt>
<a name="L146"></a><tt class="py-lineno">146</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-39" class="py-name" targets="Method pyxmpp.client.Client.authenticated()=pyxmpp.client.Client-class.html#authenticated,Method pyxmpp.jabberd.component.Component.authenticated()=pyxmpp.jabberd.component.Component-class.html#authenticated"><a title="pyxmpp.client.Client.authenticated
pyxmpp.jabberd.component.Component.authenticated" class="py-name" href="#" onclick="return doclink('link-39', 'authenticated', 'link-39');">authenticated</a></tt><tt class="py-op">:</tt> </tt>
<a name="L147"></a><tt class="py-lineno">147</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">__logger</tt><tt class="py-op">.</tt><tt class="py-name">debug</tt><tt class="py-op">(</tt><tt class="py-string">"_auth: already authenticated"</tt><tt class="py-op">)</tt> </tt>
<a name="L148"></a><tt class="py-lineno">148</tt>  <tt class="py-line">            <tt class="py-keyword">return</tt> </tt>
<a name="L149"></a><tt class="py-lineno">149</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">__logger</tt><tt class="py-op">.</tt><tt class="py-name">debug</tt><tt class="py-op">(</tt><tt class="py-string">"doing handshake..."</tt><tt class="py-op">)</tt> </tt>
<a name="L150"></a><tt class="py-lineno">150</tt>  <tt class="py-line">        <tt class="py-name">hash_value</tt><tt class="py-op">=</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-40" class="py-name" targets="Method pyxmpp.jabberd.componentstream.ComponentStream._compute_handshake()=pyxmpp.jabberd.componentstream.ComponentStream-class.html#_compute_handshake"><a title="pyxmpp.jabberd.componentstream.ComponentStream._compute_handshake" class="py-name" href="#" onclick="return doclink('link-40', '_compute_handshake', 'link-40');">_compute_handshake</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L151"></a><tt class="py-lineno">151</tt>  <tt class="py-line">        <tt class="py-name">n</tt><tt class="py-op">=</tt><tt id="link-41" class="py-name"><a title="pyxmpp.xmlextra.common_root" class="py-name" href="#" onclick="return doclink('link-41', 'common_root', 'link-10');">common_root</a></tt><tt class="py-op">.</tt><tt class="py-name">newTextChild</tt><tt class="py-op">(</tt><tt class="py-name">None</tt><tt class="py-op">,</tt><tt class="py-string">"handshake"</tt><tt class="py-op">,</tt><tt class="py-name">hash_value</tt><tt class="py-op">)</tt> </tt>
<a name="L152"></a><tt class="py-lineno">152</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-42" class="py-name" targets="Method pyxmpp.streambase.StreamBase._write_node()=pyxmpp.streambase.StreamBase-class.html#_write_node"><a title="pyxmpp.streambase.StreamBase._write_node" class="py-name" href="#" onclick="return doclink('link-42', '_write_node', 'link-42');">_write_node</a></tt><tt class="py-op">(</tt><tt class="py-name">n</tt><tt class="py-op">)</tt> </tt>
<a name="L153"></a><tt class="py-lineno">153</tt>  <tt class="py-line">        <tt class="py-name">n</tt><tt class="py-op">.</tt><tt class="py-name">unlinkNode</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L154"></a><tt class="py-lineno">154</tt>  <tt class="py-line">        <tt class="py-name">n</tt><tt class="py-op">.</tt><tt class="py-name">freeNode</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L155"></a><tt class="py-lineno">155</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">__logger</tt><tt class="py-op">.</tt><tt class="py-name">debug</tt><tt class="py-op">(</tt><tt class="py-string">"handshake hash sent."</tt><tt class="py-op">)</tt> </tt>
</div><a name="L156"></a><tt class="py-lineno">156</tt>  <tt class="py-line"> </tt>
<a name="ComponentStream._process_node"></a><div id="ComponentStream._process_node-def"><a name="L157"></a><tt class="py-lineno">157</tt> <a class="py-toggle" href="#" id="ComponentStream._process_node-toggle" onclick="return toggle('ComponentStream._process_node');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jabberd.componentstream.ComponentStream-class.html#_process_node">_process_node</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">node</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="ComponentStream._process_node-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="ComponentStream._process_node-expanded"><a name="L158"></a><tt class="py-lineno">158</tt>  <tt class="py-line">        <tt class="py-docstring">"""Process first level element of the stream.</tt> </tt>
<a name="L159"></a><tt class="py-lineno">159</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L160"></a><tt class="py-lineno">160</tt>  <tt class="py-line"><tt class="py-docstring">        Handle component handshake (authentication) element, and</tt> </tt>
<a name="L161"></a><tt class="py-lineno">161</tt>  <tt class="py-line"><tt class="py-docstring">        treat elements in "jabber:component:accept", "jabber:client"</tt> </tt>
<a name="L162"></a><tt class="py-lineno">162</tt>  <tt class="py-line"><tt class="py-docstring">        and "jabber:server" equally (pass to `self.process_stanza`).</tt> </tt>
<a name="L163"></a><tt class="py-lineno">163</tt>  <tt class="py-line"><tt class="py-docstring">        All other elements are passed to `Stream._process_node`.</tt> </tt>
<a name="L164"></a><tt class="py-lineno">164</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L165"></a><tt class="py-lineno">165</tt>  <tt class="py-line"><tt class="py-docstring">        :Parameters:</tt> </tt>
<a name="L166"></a><tt class="py-lineno">166</tt>  <tt class="py-line"><tt class="py-docstring">            - `node`: XML node describing the element</tt> </tt>
<a name="L167"></a><tt class="py-lineno">167</tt>  <tt class="py-line"><tt class="py-docstring">        """</tt> </tt>
<a name="L168"></a><tt class="py-lineno">168</tt>  <tt class="py-line">        <tt id="link-43" class="py-name" targets="Variable pyxmpp.jabber.muccore.MucAdminQuery.ns=pyxmpp.jabber.muccore.MucAdminQuery-class.html#ns,Variable pyxmpp.jabber.muccore.MucUserX.ns=pyxmpp.jabber.muccore.MucUserX-class.html#ns,Variable pyxmpp.jabber.muccore.MucX.ns=pyxmpp.jabber.muccore.MucX-class.html#ns,Variable pyxmpp.jabber.muccore.MucXBase.ns=pyxmpp.jabber.muccore.MucXBase-class.html#ns"><a title="pyxmpp.jabber.muccore.MucAdminQuery.ns
pyxmpp.jabber.muccore.MucUserX.ns
pyxmpp.jabber.muccore.MucX.ns
pyxmpp.jabber.muccore.MucXBase.ns" class="py-name" href="#" onclick="return doclink('link-43', 'ns', 'link-43');">ns</a></tt><tt class="py-op">=</tt><tt id="link-44" class="py-name"><a title="pyxmpp.jabber.disco.DiscoInfo.node
pyxmpp.jabber.disco.DiscoItem.node
pyxmpp.jabber.disco.DiscoItems.node
pyxmpp.jid.JID.node" class="py-name" href="#" onclick="return doclink('link-44', 'node', 'link-26');">node</a></tt><tt class="py-op">.</tt><tt id="link-45" class="py-name"><a title="pyxmpp.jabber.muccore.MucAdminQuery.ns
pyxmpp.jabber.muccore.MucUserX.ns
pyxmpp.jabber.muccore.MucX.ns
pyxmpp.jabber.muccore.MucXBase.ns" class="py-name" href="#" onclick="return doclink('link-45', 'ns', 'link-43');">ns</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L169"></a><tt class="py-lineno">169</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt id="link-46" class="py-name"><a title="pyxmpp.jabber.muccore.MucAdminQuery.ns
pyxmpp.jabber.muccore.MucUserX.ns
pyxmpp.jabber.muccore.MucX.ns
pyxmpp.jabber.muccore.MucXBase.ns" class="py-name" href="#" onclick="return doclink('link-46', 'ns', 'link-43');">ns</a></tt><tt class="py-op">:</tt> </tt>
<a name="L170"></a><tt class="py-lineno">170</tt>  <tt class="py-line">            <tt class="py-name">ns_uri</tt><tt class="py-op">=</tt><tt id="link-47" class="py-name"><a title="pyxmpp.jabber.disco.DiscoInfo.node
pyxmpp.jabber.disco.DiscoItem.node
pyxmpp.jabber.disco.DiscoItems.node
pyxmpp.jid.JID.node" class="py-name" href="#" onclick="return doclink('link-47', 'node', 'link-26');">node</a></tt><tt class="py-op">.</tt><tt id="link-48" class="py-name"><a title="pyxmpp.jabber.muccore.MucAdminQuery.ns
pyxmpp.jabber.muccore.MucUserX.ns
pyxmpp.jabber.muccore.MucX.ns
pyxmpp.jabber.muccore.MucXBase.ns" class="py-name" href="#" onclick="return doclink('link-48', 'ns', 'link-43');">ns</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt><tt class="py-op">.</tt><tt class="py-name">getContent</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L171"></a><tt class="py-lineno">171</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-op">(</tt><tt class="py-keyword">not</tt> <tt id="link-49" class="py-name"><a title="pyxmpp.jabber.muccore.MucAdminQuery.ns
pyxmpp.jabber.muccore.MucUserX.ns
pyxmpp.jabber.muccore.MucX.ns
pyxmpp.jabber.muccore.MucXBase.ns" class="py-name" href="#" onclick="return doclink('link-49', 'ns', 'link-43');">ns</a></tt> <tt class="py-keyword">or</tt> <tt class="py-name">ns_uri</tt><tt class="py-op">==</tt><tt class="py-string">"jabber:component:accept"</tt><tt class="py-op">)</tt> <tt class="py-keyword">and</tt> <tt id="link-50" class="py-name"><a title="pyxmpp.jabber.disco.DiscoInfo.node
pyxmpp.jabber.disco.DiscoItem.node
pyxmpp.jabber.disco.DiscoItems.node
pyxmpp.jid.JID.node" class="py-name" href="#" onclick="return doclink('link-50', 'node', 'link-26');">node</a></tt><tt class="py-op">.</tt><tt id="link-51" class="py-name" targets="Variable pyxmpp.all.name=pyxmpp.all-module.html#name,Variable pyxmpp.interfaces.name=pyxmpp.interfaces-module.html#name,Variable pyxmpp.jabber.all.name=pyxmpp.jabber.all-module.html#name,Variable pyxmpp.jabber.disco.DiscoIdentity.name=pyxmpp.jabber.disco.DiscoIdentity-class.html#name,Variable pyxmpp.jabber.disco.DiscoItem.name=pyxmpp.jabber.disco.DiscoItem-class.html#name,Variable pyxmpp.jabberd.all.name=pyxmpp.jabberd.all-module.html#name"><a title="pyxmpp.all.name
pyxmpp.interfaces.name
pyxmpp.jabber.all.name
pyxmpp.jabber.disco.DiscoIdentity.name
pyxmpp.jabber.disco.DiscoItem.name
pyxmpp.jabberd.all.name" class="py-name" href="#" onclick="return doclink('link-51', 'name', 'link-51');">name</a></tt><tt class="py-op">==</tt><tt class="py-string">"handshake"</tt><tt class="py-op">:</tt> </tt>
<a name="L172"></a><tt class="py-lineno">172</tt>  <tt class="py-line">            <tt class="py-keyword">if</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">initiator</tt> <tt class="py-keyword">and</tt> <tt class="py-keyword">not</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-52" class="py-name"><a title="pyxmpp.client.Client.authenticated
pyxmpp.jabberd.component.Component.authenticated" class="py-name" href="#" onclick="return doclink('link-52', 'authenticated', 'link-39');">authenticated</a></tt><tt class="py-op">:</tt> </tt>
<a name="L173"></a><tt class="py-lineno">173</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-53" class="py-name"><a title="pyxmpp.client.Client.authenticated
pyxmpp.jabberd.component.Component.authenticated" class="py-name" href="#" onclick="return doclink('link-53', 'authenticated', 'link-39');">authenticated</a></tt><tt class="py-op">=</tt><tt class="py-number">1</tt> </tt>
<a name="L174"></a><tt class="py-lineno">174</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-54" class="py-name" targets="Method pyxmpp.streambase.StreamBase.state_change()=pyxmpp.streambase.StreamBase-class.html#state_change"><a title="pyxmpp.streambase.StreamBase.state_change" class="py-name" href="#" onclick="return doclink('link-54', 'state_change', 'link-54');">state_change</a></tt><tt class="py-op">(</tt><tt class="py-string">"authenticated"</tt><tt class="py-op">,</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">me</tt><tt class="py-op">)</tt> </tt>
<a name="L175"></a><tt class="py-lineno">175</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-55" class="py-name" targets="Method pyxmpp.jabber.clientstream.LegacyClientStream._post_auth()=pyxmpp.jabber.clientstream.LegacyClientStream-class.html#_post_auth,Method pyxmpp.streambase.StreamBase._post_auth()=pyxmpp.streambase.StreamBase-class.html#_post_auth"><a title="pyxmpp.jabber.clientstream.LegacyClientStream._post_auth
pyxmpp.streambase.StreamBase._post_auth" class="py-name" href="#" onclick="return doclink('link-55', '_post_auth', 'link-55');">_post_auth</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L176"></a><tt class="py-lineno">176</tt>  <tt class="py-line">                <tt class="py-keyword">return</tt> </tt>
<a name="L177"></a><tt class="py-lineno">177</tt>  <tt class="py-line">            <tt class="py-keyword">elif</tt> <tt class="py-keyword">not</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-56" class="py-name"><a title="pyxmpp.client.Client.authenticated
pyxmpp.jabberd.component.Component.authenticated" class="py-name" href="#" onclick="return doclink('link-56', 'authenticated', 'link-39');">authenticated</a></tt> <tt class="py-keyword">and</tt> <tt id="link-57" class="py-name"><a title="pyxmpp.jabber.disco.DiscoInfo.node
pyxmpp.jabber.disco.DiscoItem.node
pyxmpp.jabber.disco.DiscoItems.node
pyxmpp.jid.JID.node" class="py-name" href="#" onclick="return doclink('link-57', 'node', 'link-26');">node</a></tt><tt class="py-op">.</tt><tt class="py-name">getContent</tt><tt class="py-op">(</tt><tt class="py-op">)</tt><tt class="py-op">==</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-58" class="py-name"><a title="pyxmpp.jabberd.componentstream.ComponentStream._compute_handshake" class="py-name" href="#" onclick="return doclink('link-58', '_compute_handshake', 'link-40');">_compute_handshake</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L178"></a><tt class="py-lineno">178</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">peer</tt><tt class="py-op">=</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">me</tt> </tt>
<a name="L179"></a><tt class="py-lineno">179</tt>  <tt class="py-line">                <tt class="py-name">n</tt><tt class="py-op">=</tt><tt id="link-59" class="py-name"><a title="pyxmpp.xmlextra.common_doc" class="py-name" href="#" onclick="return doclink('link-59', 'common_doc', 'link-9');">common_doc</a></tt><tt class="py-op">.</tt><tt class="py-name">newChild</tt><tt class="py-op">(</tt><tt class="py-name">None</tt><tt class="py-op">,</tt><tt class="py-string">"handshake"</tt><tt class="py-op">,</tt><tt class="py-name">None</tt><tt class="py-op">)</tt> </tt>
<a name="L180"></a><tt class="py-lineno">180</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-60" class="py-name"><a title="pyxmpp.streambase.StreamBase._write_node" class="py-name" href="#" onclick="return doclink('link-60', '_write_node', 'link-42');">_write_node</a></tt><tt class="py-op">(</tt><tt class="py-name">n</tt><tt class="py-op">)</tt> </tt>
<a name="L181"></a><tt class="py-lineno">181</tt>  <tt class="py-line">                <tt class="py-name">n</tt><tt class="py-op">.</tt><tt class="py-name">unlinkNode</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L182"></a><tt class="py-lineno">182</tt>  <tt class="py-line">                <tt class="py-name">n</tt><tt class="py-op">.</tt><tt class="py-name">freeNode</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L183"></a><tt class="py-lineno">183</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">peer_authenticated</tt><tt class="py-op">=</tt><tt class="py-number">1</tt> </tt>
<a name="L184"></a><tt class="py-lineno">184</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-61" class="py-name"><a title="pyxmpp.streambase.StreamBase.state_change" class="py-name" href="#" onclick="return doclink('link-61', 'state_change', 'link-54');">state_change</a></tt><tt class="py-op">(</tt><tt class="py-string">"authenticated"</tt><tt class="py-op">,</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">peer</tt><tt class="py-op">)</tt> </tt>
<a name="L185"></a><tt class="py-lineno">185</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-62" class="py-name"><a title="pyxmpp.jabber.clientstream.LegacyClientStream._post_auth
pyxmpp.streambase.StreamBase._post_auth" class="py-name" href="#" onclick="return doclink('link-62', '_post_auth', 'link-55');">_post_auth</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L186"></a><tt class="py-lineno">186</tt>  <tt class="py-line">                <tt class="py-keyword">return</tt> </tt>
<a name="L187"></a><tt class="py-lineno">187</tt>  <tt class="py-line">            <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L188"></a><tt class="py-lineno">188</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-63" class="py-name" targets="Method pyxmpp.streambase.StreamBase._send_stream_error()=pyxmpp.streambase.StreamBase-class.html#_send_stream_error"><a title="pyxmpp.streambase.StreamBase._send_stream_error" class="py-name" href="#" onclick="return doclink('link-63', '_send_stream_error', 'link-63');">_send_stream_error</a></tt><tt class="py-op">(</tt><tt class="py-string">"not-authorized"</tt><tt class="py-op">)</tt> </tt>
<a name="L189"></a><tt class="py-lineno">189</tt>  <tt class="py-line">                <tt class="py-keyword">raise</tt> <tt id="link-64" class="py-name"><a title="pyxmpp.exceptions.FatalComponentStreamError" class="py-name" href="#" onclick="return doclink('link-64', 'FatalComponentStreamError', 'link-19');">FatalComponentStreamError</a></tt><tt class="py-op">,</tt><tt class="py-string">"Hanshake error."</tt> </tt>
<a name="L190"></a><tt class="py-lineno">190</tt>  <tt class="py-line"> </tt>
<a name="L191"></a><tt class="py-lineno">191</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">ns_uri</tt> <tt class="py-keyword">in</tt> <tt class="py-op">(</tt><tt class="py-string">"jabber:component:accept"</tt><tt class="py-op">,</tt><tt class="py-string">"jabber:client"</tt><tt class="py-op">,</tt><tt class="py-string">"jabber:server"</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L192"></a><tt class="py-lineno">192</tt>  <tt class="py-line">            <tt id="link-65" class="py-name" targets="Module pyxmpp.stanza=pyxmpp.stanza-module.html,Method pyxmpp.streambase.StreamBase.stanza()=pyxmpp.streambase.StreamBase-class.html#stanza,Method pyxmpp.xmlextra.StreamHandler.stanza()=pyxmpp.xmlextra.StreamHandler-class.html#stanza"><a title="pyxmpp.stanza
pyxmpp.streambase.StreamBase.stanza
pyxmpp.xmlextra.StreamHandler.stanza" class="py-name" href="#" onclick="return doclink('link-65', 'stanza', 'link-65');">stanza</a></tt><tt class="py-op">=</tt><tt id="link-66" class="py-name"><a title="pyxmpp.streambase.stanza_factory" class="py-name" href="#" onclick="return doclink('link-66', 'stanza_factory', 'link-5');">stanza_factory</a></tt><tt class="py-op">(</tt><tt id="link-67" class="py-name"><a title="pyxmpp.jabber.disco.DiscoInfo.node
pyxmpp.jabber.disco.DiscoItem.node
pyxmpp.jabber.disco.DiscoItems.node
pyxmpp.jid.JID.node" class="py-name" href="#" onclick="return doclink('link-67', 'node', 'link-26');">node</a></tt><tt class="py-op">)</tt> </tt>
<a name="L193"></a><tt class="py-lineno">193</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">lock</tt><tt class="py-op">.</tt><tt class="py-name">release</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L194"></a><tt class="py-lineno">194</tt>  <tt class="py-line">            <tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L195"></a><tt class="py-lineno">195</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-68" class="py-name" targets="Method pyxmpp.stanzaprocessor.StanzaProcessor.process_stanza()=pyxmpp.stanzaprocessor.StanzaProcessor-class.html#process_stanza"><a title="pyxmpp.stanzaprocessor.StanzaProcessor.process_stanza" class="py-name" href="#" onclick="return doclink('link-68', 'process_stanza', 'link-68');">process_stanza</a></tt><tt class="py-op">(</tt><tt id="link-69" class="py-name"><a title="pyxmpp.stanza
pyxmpp.streambase.StreamBase.stanza
pyxmpp.xmlextra.StreamHandler.stanza" class="py-name" href="#" onclick="return doclink('link-69', 'stanza', 'link-65');">stanza</a></tt><tt class="py-op">)</tt> </tt>
<a name="L196"></a><tt class="py-lineno">196</tt>  <tt class="py-line">            <tt class="py-keyword">finally</tt><tt class="py-op">:</tt> </tt>
<a name="L197"></a><tt class="py-lineno">197</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">lock</tt><tt class="py-op">.</tt><tt class="py-name">acquire</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L198"></a><tt class="py-lineno">198</tt>  <tt class="py-line">                <tt id="link-70" class="py-name"><a title="pyxmpp.stanza
pyxmpp.streambase.StreamBase.stanza
pyxmpp.xmlextra.StreamHandler.stanza" class="py-name" href="#" onclick="return doclink('link-70', 'stanza', 'link-65');">stanza</a></tt><tt class="py-op">.</tt><tt id="link-71" class="py-name" targets="Method pyxmpp.error.ErrorNode.free()=pyxmpp.error.ErrorNode-class.html#free,Method pyxmpp.jabber.muccore.MucIq.free()=pyxmpp.jabber.muccore.MucIq-class.html#free,Method pyxmpp.jabber.muccore.MucPresence.free()=pyxmpp.jabber.muccore.MucPresence-class.html#free,Method pyxmpp.jabber.muccore.MucXBase.free()=pyxmpp.jabber.muccore.MucXBase-class.html#free,Method pyxmpp.stanza.Stanza.free()=pyxmpp.stanza.Stanza-class.html#free"><a title="pyxmpp.error.ErrorNode.free
pyxmpp.jabber.muccore.MucIq.free
pyxmpp.jabber.muccore.MucPresence.free
pyxmpp.jabber.muccore.MucXBase.free
pyxmpp.stanza.Stanza.free" class="py-name" href="#" onclick="return doclink('link-71', 'free', 'link-71');">free</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L199"></a><tt class="py-lineno">199</tt>  <tt class="py-line">            <tt class="py-keyword">return</tt> </tt>
<a name="L200"></a><tt class="py-lineno">200</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt id="link-72" class="py-name"><a title="pyxmpp.stream.Stream" class="py-name" href="#" onclick="return doclink('link-72', 'Stream', 'link-2');">Stream</a></tt><tt class="py-op">.</tt><tt id="link-73" class="py-name" targets="Method pyxmpp.jabberd.componentstream.ComponentStream._process_node()=pyxmpp.jabberd.componentstream.ComponentStream-class.html#_process_node,Method pyxmpp.stream.Stream._process_node()=pyxmpp.stream.Stream-class.html#_process_node,Method pyxmpp.streambase.StreamBase._process_node()=pyxmpp.streambase.StreamBase-class.html#_process_node"><a title="pyxmpp.jabberd.componentstream.ComponentStream._process_node
pyxmpp.stream.Stream._process_node
pyxmpp.streambase.StreamBase._process_node" class="py-name" href="#" onclick="return doclink('link-73', '_process_node', 'link-73');">_process_node</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">,</tt><tt id="link-74" class="py-name"><a title="pyxmpp.jabber.disco.DiscoInfo.node
pyxmpp.jabber.disco.DiscoItem.node
pyxmpp.jabber.disco.DiscoItems.node
pyxmpp.jid.JID.node" class="py-name" href="#" onclick="return doclink('link-74', 'node', 'link-26');">node</a></tt><tt class="py-op">)</tt> </tt>
</div></div><a name="L201"></a><tt class="py-lineno">201</tt>  <tt class="py-line"> </tt>
<a name="L202"></a><tt class="py-lineno">202</tt>  <tt class="py-line"><tt class="py-comment"># vi: sts=4 et sw=4</tt> </tt>
<a name="L203"></a><tt class="py-lineno">203</tt>  <tt class="py-line"> </tt><script type="text/javascript">
<!--
expandto(location.href);
// -->
</script>
</pre>
<br />
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%%">
  <tr>
    <td align="left" class="footer">
    Generated by Epydoc 3.0.1 on Sun May  8 13:35:06 2011
    </td>
    <td align="right" class="footer">
      <a target="mainFrame" href="http://epydoc.sourceforge.net"
        >http://epydoc.sourceforge.net</a>
    </td>
  </tr>
</table>

<script type="text/javascript">
  <!--
  // Private objects are initially displayed (because if
  // javascript is turned off then we want them to be
  // visible); but by default, we want to hide them.  So hide
  // them unless we have a cookie that says to show them.
  checkCookie();
  // -->
</script>
</body>
</html>
